com.fasterxml.jackson.databind.jsontype.impl

## Class AsExistingPropertyTypeSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.jsontype.TypeSerializer
  - - com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase
    - - com.fasterxml.jackson.databind.jsontype.impl.AsArrayTypeSerializer
      - - com.fasterxml.jackson.databind.jsontype.impl.AsPropertyTypeSerializer
        - - com.fasterxml.jackson.databind.jsontype.impl.AsExistingPropertyTypeSerializer

-     public class AsExistingPropertyTypeSerializer
      extends AsPropertyTypeSerializer

  Type serializer used with `JsonTypeInfo.As.EXISTING_PROPERTY` inclusion mechanism. Expects type information to be a well-defined property on all sub-classes.

- - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.jsontype.impl.AsPropertyTypeSerializer

      `_typePropertyName`

    - ### Fields inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

      `_idResolver, _property`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsExistingPropertyTypeSerializer(TypeIdResolver idRes, BeanProperty property, String propName)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AsExistingPropertyTypeSerializer` | `forProperty(BeanProperty prop)` Method called to create contextual version, to be used for values of given property.
    `JsonTypeInfo.As` | `getTypeInclusion()` Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.
    `void` | `writeCustomTypePrefixForObject(Object value, JsonGenerator gen, String typeId)` Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar), using specified custom type id instead of calling `TypeIdResolver`.
    `void` | `writeTypePrefixForObject(Object value, JsonGenerator gen)` Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar).
    `void` | `writeTypePrefixForObject(Object value, JsonGenerator gen, Class<?> type)` Alternative version of the prefix-for-object method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type

    - ### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.AsPropertyTypeSerializer

      `getPropertyName, writeCustomTypeSuffixForObject, writeTypeSuffixForObject`

    - ### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.AsArrayTypeSerializer

      `writeCustomTypePrefixForArray, writeCustomTypePrefixForScalar, writeCustomTypeSuffixForArray, writeCustomTypeSuffixForScalar, writeTypePrefixForArray, writeTypePrefixForArray, writeTypePrefixForScalar, writeTypePrefixForScalar, writeTypeSuffixForArray, writeTypeSuffixForScalar`

    - ### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

      `getTypeIdResolver, handleMissingId, idFromValue, idFromValueAndType`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AsExistingPropertyTypeSerializer

          public AsExistingPropertyTypeSerializer(TypeIdResolver idRes,
                                          BeanProperty property,
                                          String propName)

  - ### Method Detail

    - #### forProperty

          public AsExistingPropertyTypeSerializer forProperty(BeanProperty prop)

      Description copied from class: `TypeSerializer`
      Method called to create contextual version, to be used for values of given property. This may be the type itself (as is the case for bean properties), or values contained (for `Collection` or `Map` valued properties).
      Overrides:
        `forProperty` in class `AsPropertyTypeSerializer`

    - #### getTypeInclusion

          public JsonTypeInfo.As getTypeInclusion()

      Description copied from class: `TypeSerializer`
      Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.
      Overrides:
        `getTypeInclusion` in class `AsPropertyTypeSerializer`

    - #### writeTypePrefixForObject

          public void writeTypePrefixForObject(Object value,
                                      JsonGenerator gen)
                                        throws IOException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar). This means that context after call must be JSON Object, meaning that caller can then proceed to output field entries.
      Overrides:
        `writeTypePrefixForObject` in class `AsPropertyTypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `gen` - Generator to use for writing type information
      Throws:
        `IOException`

    - #### writeTypePrefixForObject

          public void writeTypePrefixForObject(Object value,
                                      JsonGenerator gen,
                                      Class<?> type)
                                        throws IOException

      Description copied from class: `TypeSerializer`
      Alternative version of the prefix-for-object method, which is given actual type to use (instead of using exact type of the value); typically a super type of actual value type
      Overrides:
        `writeTypePrefixForObject` in class `AsPropertyTypeSerializer`
      Throws:
        `IOException`

    - #### writeCustomTypePrefixForObject

          public void writeCustomTypePrefixForObject(Object value,
                                            JsonGenerator gen,
                                            String typeId)
                                              throws IOException

      Description copied from class: `TypeSerializer`
      Method called to write initial part of type information for given value, when it will be output as JSON Object value (not as JSON Array or scalar), using specified custom type id instead of calling `TypeIdResolver`. This means that context after call must be JSON Object, meaning that caller can then proceed to output field entries.
      Overrides:
        `writeCustomTypePrefixForObject` in class `AsPropertyTypeSerializer`
      Parameters:
        `value` - Value that will be serialized, for which type information is to be written
        `gen` - Generator to use for writing type information
        `typeId` - Exact type id to use
      Throws:
        `IOException`

Copyright © 2008–2016 FasterXML. All rights reserved.